export declare type IContext = any;
export declare type IConstraint = any;
export declare type IConstraintGenerator = (context: IContext) => (Promise<any> | any);
export declare type ICondition = (context: IContext) => boolean;
export declare type IScopeRequest = string;
export interface IMap<T> {
    [name: string]: T;
}
export interface IRoleDef {
    resources: IResourceDefs;
    inherits?: string[];
}
export declare type IResourceDef = IMap<IScopeDef[]>;
export declare type IRoleDefs = IMap<IRoleDef>;
export declare type IResourceDefs = IMap<IResourceDef>;
export declare type IExplanation = any;
export declare type IExplanationGenerator = (permission: IPermission, context: IContext) => IExplanation;
export declare type IFieldDefs = IMap<boolean>;
export declare type IEffect = 'grant' | 'deny';
export declare type IFieldTest = (field: string | void, context?: IContext) => (Promise<boolean> | boolean);
export declare type IFieldGenerator = (ctx: IContext) => (Promise<IFieldDefs> | IFieldDefs);
export interface IPermission {
    granted: IScopeRequest | void;
    denied: IScopeRequest[] | void;
    constraint: IConstraint;
    fields: IFieldDefs;
    field(field: string): boolean;
}
export interface IScopeDef {
    condition: ICondition;
    constraint?: IConstraintGenerator | IConstraint;
    effect: IEffect;
    fieldGenerator?: IFieldGenerator;
    explanationGenerator?: IExplanationGenerator;
}
